"use strict";
//----------------------
// <auto-generated>
//     Generated using the NSwag toolchain v9.10.19.0 (Newtonsoft.Json v9.0.0.0) (http://NJsonSchema.org)
// </auto-generated>
//----------------------
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
/** Describes the kind of data to be formatted. */
var DataFormat;
(function (DataFormat) {
    DataFormat[DataFormat["Default"] = 'default'] = "Default";
    DataFormat[DataFormat["Email"] = 'email'] = "Email";
    DataFormat[DataFormat["Token"] = 'token'] = "Token";
    DataFormat[DataFormat["Path"] = 'path'] = "Path";
    DataFormat[DataFormat["Text"] = 'text'] = "Text";
    DataFormat[DataFormat["Uri"] = 'uri'] = "Uri";
    DataFormat[DataFormat["Omit"] = 'omit'] = "Omit";
    DataFormat[DataFormat["OmitDefault"] = 'omitDefault'] = "OmitDefault";
    DataFormat[DataFormat["Hide"] = 'hide'] = "Hide";
    DataFormat[DataFormat["SingleMember"] = 'singleMember'] = "SingleMember";
})(DataFormat = exports.DataFormat || (exports.DataFormat = {}));
/** Creates a decorator that saves the property format in a map attached to the class constructor. */
function dataFormat(...format) {
    return function (target, propertyKey) {
        if (!target.constructor.dataFormat) {
            target.constructor.dataFormat = {};
        }
        target.constructor.dataFormat[propertyKey] = format;
    };
}
exports.dataFormat = dataFormat;
class EventArgs {
}
exports.EventArgs = EventArgs;
/** Notification class for contact service */
class NotifyContactServiceEventArgs extends EventArgs {
}
exports.NotifyContactServiceEventArgs = NotifyContactServiceEventArgs;
/** The presence status default options */
var PresenceStatus;
(function (PresenceStatus) {
    PresenceStatus[PresenceStatus["Unknown"] = 'unknown'] = "Unknown";
    PresenceStatus[PresenceStatus["Available"] = 'available'] = "Available";
    PresenceStatus[PresenceStatus["Busy"] = 'busy'] = "Busy";
    PresenceStatus[PresenceStatus["DoNotDisturb"] = 'doNotDisturb'] = "DoNotDisturb";
    PresenceStatus[PresenceStatus["Away"] = 'away'] = "Away";
    PresenceStatus[PresenceStatus["Invisible"] = 'invisible'] = "Invisible";
    PresenceStatus[PresenceStatus["Offline"] = 'offline'] = "Offline";
})(PresenceStatus = exports.PresenceStatus || (exports.PresenceStatus = {}));
/** Contact property types */
var ContactProperty;
(function (ContactProperty) {
    ContactProperty[ContactProperty["DisplayName"] = 'displayName'] = "DisplayName";
    ContactProperty[ContactProperty["Email"] = 'email'] = "Email";
    ContactProperty[ContactProperty["AvatarUri"] = 'avatarUri'] = "AvatarUri";
    ContactProperty[ContactProperty["Status"] = 'status'] = "Status";
})(ContactProperty = exports.ContactProperty || (exports.ContactProperty = {}));
/** Contact entity */
class Contact {
}
exports.Contact = Contact;
/** Empty parameters */
class EmptyRequest {
}
exports.EmptyRequest = EmptyRequest;
/** Empty result */
class EmptyResponse {
}
exports.EmptyResponse = EmptyResponse;
/** Parameters passed during Initialize method */
class InitializeRequest {
}
exports.InitializeRequest = InitializeRequest;
/** Definition of a workspace folder */
class WorkspaceFolder {
}
exports.WorkspaceFolder = WorkspaceFolder;
/** A workspace Uri from vscode */
class WorkspaceUri {
}
exports.WorkspaceUri = WorkspaceUri;
/** Capabilities that a service would offer */
class Capabilities {
}
exports.Capabilities = Capabilities;
/** Returned on the Initialized method */
class InitializeResponse {
}
__decorate([
    dataFormat(Capabilities)
], InitializeResponse.prototype, "capabilities", void 0);
exports.InitializeResponse = InitializeResponse;
/** A presence status changed for a contact entity */
class ContactPresenceUpdate {
}
exports.ContactPresenceUpdate = ContactPresenceUpdate;
/** Batch of presence changed for multiple contacts */
class PresenceChangedNotification {
}
__decorate([
    dataFormat(ContactPresenceUpdate)
], PresenceChangedNotification.prototype, "changes", void 0);
exports.PresenceChangedNotification = PresenceChangedNotification;
class ContactPropertyValueChanged {
}
exports.ContactPropertyValueChanged = ContactPropertyValueChanged;
class ContactChangedNotification {
}
exports.ContactChangedNotification = ContactChangedNotification;
class InviteRequest {
}
exports.InviteRequest = InviteRequest;
class InviteReceivedNotification {
}
__decorate([
    dataFormat(Contact)
], InviteReceivedNotification.prototype, "fromContact", void 0);
exports.InviteReceivedNotification = InviteReceivedNotification;
class PublishPresenceRequest {
}
exports.PublishPresenceRequest = PublishPresenceRequest;
class SelfContactNotification {
}
__decorate([
    dataFormat(Contact)
], SelfContactNotification.prototype, "contact", void 0);
exports.SelfContactNotification = SelfContactNotification;
class ContactsNotification {
}
__decorate([
    dataFormat(Contact)
], ContactsNotification.prototype, "contacts", void 0);
exports.ContactsNotification = ContactsNotification;
class ContactPresenceRequest {
}
__decorate([
    dataFormat(Contact)
], ContactPresenceRequest.prototype, "contacts", void 0);
exports.ContactPresenceRequest = ContactPresenceRequest;
class ContactResponse {
}
__decorate([
    dataFormat(Contact)
], ContactResponse.prototype, "contact", void 0);
exports.ContactResponse = ContactResponse;
class ContactPresenceResponse {
}
__decorate([
    dataFormat(ContactResponse)
], ContactPresenceResponse.prototype, "contacts", void 0);
exports.ContactPresenceResponse = ContactPresenceResponse;
class ContactPresenceDisposeRequest {
}
exports.ContactPresenceDisposeRequest = ContactPresenceDisposeRequest;
class SearchContactProperty {
}
exports.SearchContactProperty = SearchContactProperty;
class SearchContactsRequest {
}
__decorate([
    dataFormat(SearchContactProperty)
], SearchContactsRequest.prototype, "queryOptions", void 0);
exports.SearchContactsRequest = SearchContactsRequest;
class SearchContactsResponse {
}
__decorate([
    dataFormat(Contact)
], SearchContactsResponse.prototype, "results", void 0);
exports.SearchContactsResponse = SearchContactsResponse;
class MessagePayload {
}
exports.MessagePayload = MessagePayload;
class SendMessageRequest extends MessagePayload {
}
exports.SendMessageRequest = SendMessageRequest;
class MessageReceivedNotification extends MessagePayload {
}
exports.MessageReceivedNotification = MessageReceivedNotification;
var Methods;
(function (Methods) {
    Methods["RequestInitializeName"] = "initialize";
    Methods["RequestDisposeName"] = "dispose";
    Methods["RequestInviteName"] = "inviteLink";
    Methods["RequestPublishPresenceName"] = "publishPresence";
    Methods["RequestContactPresenceName"] = "contactPresenceRequest";
    Methods["RequestContactPresenceDisposeName"] = "contactPresenceDispose";
    Methods["RequestSearchContactsName"] = "searchContacts";
    Methods["RequestSendMessageName"] = "sendMessageRequest";
    Methods["NotifyPresenceChangedName"] = "presenceChanged";
    Methods["NotifySelfContactName"] = "selfContact";
    Methods["NotifyAvailableUsersName"] = "availableUsers";
    Methods["NotifyAvailableUsersAddedName"] = "availableUsersAdded";
    Methods["NotifyAvailableUsersRemovedName"] = "availableUsersRemoved";
    Methods["NotifyInviteReceivedName"] = "inviteLinkReceived";
    Methods["NotifyContactChangedName"] = "contactChanged";
    Methods["NotifySuggestedUsersName"] = "suggestedUsers";
    Methods["NotifyCapabilitiesUpdateName"] = "capabilitiesUpdate";
    Methods["NotifyMessageReceivedName"] = "messageReceived";
})(Methods = exports.Methods || (exports.Methods = {}));
/* tslint:disable:variable-name */
exports.ContactServiceProvider = {
    methods: ['request'],
    events: ['notified'],
};

//# sourceMappingURL=ContactProtocol.js.map
